/********************************(RTC-DS1307.c)***
 *  RTC (DS1307)@Cu
 ****************************************************/
#include "string.h"
#include "myProject.h"

#define DS1307  0x68    // RTCI2CAhX

#define NO_PRINTF

//=== RTCpϐ =======
                
uint16_t J_Week[]={'','','','','','','y'};
//char     D_Week[][4]={"Sun","Mon","Tue","Wed","Thu","Fri","Sat"};

uint8_t DayTm[] = { 0,	// seconds
                    30,	// minutes
                    10,	// Hours(24h)
                    4,	// day[week]
                    1,	// date
                    1,	// month
                    25,	// year@(2j
                    0	// SQW/OUT
                 };

static uint8_t ClockMd = 1;  // N͎v\[h
static uint8_t Sec = 0;

/****** ėp֐ ***************************/
//---- BCD2iɕϊ
uint8_t bcd2bin(uint8_t bcd){
    return  ((bcd >> 4)& 0x0F) * 10 + (bcd & 0x0F);
}

//---- 2iBCDɕϊ
uint8_t bin2bcd(uint8_t bin){
    return  (uint8_t)((uint16_t)(bin/10) << 4)+(bin % 10);
}

//---- 񂩂琔loA1oCgzɋtŊi[
//      buf:    oli[1oCgz
//      src:    lo
//      delim:  ؂蕶𕶎ɂ
//  i߂lj: 擾ol̐
uint8_t get_NumRev(uint8_t *buf, char *src, char *delim){
    char    *ptr;
    uint8_t bt, n = 0;
    ptr = strtok(src, delim);
    while(ptr != NULL){
        bt = (uint8_t)atoi(ptr);	//f[^ł0Ԃ
        *buf-- = bt;
        n++;
        ptr = strtok(NULL, delim);
    }
    return n;
}

/****** RTCp֐ ******************************/
//--- RTCadrԒndatf[^
void RTC_write(uint8_t adr, uint8_t dat){
    uint8_t bf[3];
    bf[0] = adr;                     // Address = adr
    bf[1] = dat;                     // Set Data
    I2C1_WriteNBytes(DS1307, bf, 2); // Write Data
}

//--- RTCadrԒñf[^ǂݍ
uint8_t RTC_read(uint8_t adr){
    uint8_t bf[3];
    bf[0] = adr;                     // Address = adr
    I2C1_WriteNBytes(DS1307, bf, 1); // Set Address
    I2C1_ReadNBytes(DS1307, bf, 1);  // Read Data
    return bf[0];
}

//--- RTC̑SĂrtcf[^buf[]ǂݍ
void RTC_readAll(uint8_t *buf,uint8_t bcd){
    uint8_t rtc[8],i;
    rtc[0] = 0;                       // Address = 0
    I2C1_WriteNBytes(DS1307, rtc, 1); // Set Address
    I2C1_ReadNBytes(DS1307, rtc, 8);  // Read Data
    for(i = 0; i < 8; i++){
        if(bcd) buf[i] = bcd2bin(rtc[i]);
        else    buf[i] = rtc[i];
    }
}

//--- RTC̑SĂrtcf[^
void RTC_writeAll(uint8_t *buf){
    uint8_t rtc[8],i;
    rtc[0]=0;                         // Address = 0
    for(i=0; i < 8; i++){
        rtc[i+1] = bin2bcd(buf[i]);
    }
    I2C1_WriteNBytes(DS1307, rtc, 9);
}

//--- RTC̎wAhXnoCg̃f[^
//      buf:    ރf[^i[ꂽz
//      adr:    RTCAhX
//      n:      ރoCg
void RTC_writePrt(uint8_t *buf, uint8_t adr, uint8_t n){
    uint8_t rtc[9],i;
    rtc[0] = adr;                      // Address = adr
    for(i = 0;i < n; i++){
        rtc[i+1] = bin2bcd(buf[adr+i]);
    }
    I2C1_WriteNBytes(DS1307, rtc, n+1);
}


void RTC_init(){
    RTC_writeAll(DayTm);
}

char *RTC_HsetBCD(char *str, uint8_t bcd,uint8_t zero){
    uint8_t hcd;
    if( (zero>0) & ((bcd>>4)==0) )
        hcd = 0x20;  
    else
        hcd = 0x30 + (bcd >> 4);
    *str++ = hcd;
    hcd = 0x30 + (bcd & 0x0F);
    *str++ = hcd;
    return str;
}

void RTC_ZprtBCD(uint8_t x, uint8_t pg, uint8_t gap, uint8_t bcd,uint8_t zero){
    uint16_t kcd;
    if( (zero>0) & ((bcd>>4)==0) )
        kcd = 0x2121;  
    else
        kcd = 0x2330 + (bcd >> 4);
    i2cOLED_ZchrX(x,pg,kcd,2);
    kcd = 0x2330 + (bcd & 0x0F);
    i2cOLED_ZchrX(x+16+gap,pg,kcd,2);  
}

void RTC_2ZprtBCD(uint8_t x, uint8_t pg, uint8_t gap, uint8_t bcd,uint8_t zero){
    uint16_t kcd;
    if( (zero>0) & ((bcd>>4)==0) ){
        kcd = 0x2121;
        i2cOLED_ZchrX(x,pg,kcd,2);        
        i2cOLED_ZchrX(x,pg+2,kcd,2);      
    }else{
        kcd = 0x2659 + (bcd >> 4)*2;
        i2cOLED_ZchrX(x,pg,kcd,2);
        i2cOLED_ZchrX(x,pg+2,kcd+1,2);      
    }
    kcd = 0x2659 + (bcd & 0xF)*2;
    i2cOLED_ZchrX(x+16+gap,pg,kcd,2);
    i2cOLED_ZchrX(x+16+gap,pg+2,kcd+1,2);   
}

//---- RTC f[^OLED ɕ\(BCDf[^𗘗pj
void RTC_prtOLED(){
    char buf[20];
    uint8_t d;
    uint16_t kcd;
#ifdef NO_PRINTF
    RTC_readAll(DayTm,0);
    strcpy(buf,"2000/01/01(");
    RTC_HsetBCD(buf+2,DayTm[6],0);
    RTC_HsetBCD(buf+5,DayTm[5],1);
    RTC_HsetBCD(buf+8,DayTm[4],1);
    d = DayTm[3] & 0x0F;
    i2cOLED_HstrX(0,0,buf);
    i2cOLED_ZchrX(92,0,J_Week[d],0);
    i2cOLED_HchrX(112,0,')');
    RTC_2ZprtBCD(0,3,4,DayTm[2],1);
    i2cOLED_HchrX(40,3,0xA5);    i2cOLED_HchrX(40,5,0xA5);
    RTC_2ZprtBCD(50,3,4,DayTm[1],0);
    RTC_ZprtBCD(90,5,0,DayTm[0],0);    
#else    
    RTC_readAll(DayTm,1);
    sprintf(buf,"20%02d/%2d/%2d(%s)",DayTm[6],DayTm[5],DayTm[4],D_WEEK[DayTm[3]]);
    i2cOLED_HstrX(0,0,buf); //printf("%s  ",buf);    
    sprintf(buf,"%02d:%02d:%02d",DayTm[2],DayTm[1],DayTm[0]);
    i2cOLED_HstrX(60,3,buf); //puts(buf);
    kcd = (uint16_t)buf[0] + 0x2300; i2cOLED_ZchrX(0,5,kcd,2);
    kcd = (uint16_t)buf[1] + 0x2300; i2cOLED_ZchrX(20,5,kcd,2);
    i2cOLED_HchrX(40,5,':');
    kcd = (uint16_t)buf[3] + 0x2300; i2cOLED_ZchrX(50,5,kcd,2);
    kcd = (uint16_t)buf[4] + 0x2300; i2cOLED_ZchrX(70,5,kcd,2);
    kcd = (uint16_t)buf[6] + 0x2300; i2cOLED_ZchrX(90,5,kcd,2);
    kcd = (uint16_t)buf[7] + 0x2300; i2cOLED_ZchrX(106,5,kcd,2);
#endif
}
   
/***** R}h *********************/
//---- I(read_tIme)R}h(eXgpj	"I"
void i2cRTC_cmd_I(){
    char buf[20];
    RTC_readAll(DayTm,0);
#ifdef NO_PRINTF
    strcpy(buf,"2000/01/01(   )");
    RTC_HsetBCD(buf+2,DayTm[6],0);
    RTC_HsetBCD(buf+5,DayTm[5],0);
    RTC_HsetBCD(buf+8,DayTm[4],0);
    buf[12] = 0x30 + (DayTm[3]& 0x0F);
    puts(buf);i2cOLED_HstrX(0,0,buf);
    strcpy(buf," 00:00:00     ");
    RTC_HsetBCD(buf+1,DayTm[2],0);
    RTC_HsetBCD(buf+4,DayTm[1],0);
    RTC_HsetBCD(buf+7,DayTm[0],0);
    puts(buf);i2cOLED_HstrX(0,2,buf);
#else
    printf("20%02d/%2d/%2d/%s  ",DayTm[6],DayTm[5],DayTm[4],D_WEEK[DayTm[3]]);
    printf("%2d:%02d:%02d\n",DayTm[2],DayTm[1],DayTm[0]);
#endif
}

//---- JR}h (OLED\؂ւj	"J"
void cmd_J(){
    ClockMd ^= 1;
    i2cOLED_Clr(0,7,0);
}

//---- Y(Year)R}h(tݒpj		"Yyy/MM/dd/w"
void i2cRTC_cmd_Y(char *str){
    uint8_t n;
    n = get_NumRev(DayTm+6, str+1, "/");
    if((n > 0)&&(n < 5)){
        RTC_writePrt(DayTm, 3, 4);
    }
}

//---- s(Time)R}h(ݒpj	"Thh:mm:ss"
void i2cRTC_cmd_T(char *str){
    uint8_t n;
    n = get_NumRev(DayTm+2, str+1, ":");
    if((n > 0)&&(n < 4)){
        RTC_writePrt(DayTm, 0, 3);
    }
}

void OLED_Clock(){
    uint8_t t;
    RTC_readAll(DayTm,1);
    t = DayTm[0];
    if(Sec != t){		//  \͕bP
        if(ClockMd) RTC_prtOLED();
        Sec = t;
        IO_RA4_Toggle();
    }  
}
